

clear all

use random_dataset

br 

*Writing a program to export sub-population-wise tabulation results of treatment and compliance 

capture program drop our_program
program define our_program
 
args Pop Filename Sheet Heading Note j condition
 
 
tab treatment compliance if sub_population=="`Pop'", row matcell(cell) 

putexcel set `Filename', sheet("`Sheet'") `condition' 

putexcel A`j'="`Heading'"

local j= `j' + 2

putexcel B`j'="Compliance Type 1" C`j'= "Compliance Type 2" D`j'= "Compliance Type 3" 

local ++j 

putexcel A`j'= "T1"
putexcel B`j' = matrix(cell) 

local ++j 

putexcel A`j'= "T2"
putexcel B`j' = cell[2,1]
putexcel C`j' = cell[2,2] 
putexcel D`j' = cell[2,3]

local ++j 

mat totals= (cell[1,1]+ cell[2,1], cell[1,2] + cell[2,2], cell[1,3] + cell[2,3]) 

putexcel A`j'= "Total" 
putexcel B`j'= matrix(totals) 

local j = `j'+3 

putexcel A`j'="`Note'"

end 

*Running the program to export tabulation results for two subpopulations A and B -->

*You can alter the arguments FileName, Sheet and j to export the results in same/different files and on same/different sheets 

*Sub-population, headings and notes can be altered as well. In fact, you can even add the tabulated variables as arguments!

our_program A "Tabulation_Results" 1 "Tabulating Treatment-Compliance for Population A" "These results look fine." 2 replace //results exported on sheet 1

our_program B "Tabulation_Results" 2 "Tabulating Treatment-Compliance for Population B" "These results look fine as well." 2 modify //results exported on sheet 2
